#!/bin/bash

AppleCertificate="Certificates/AppleWWDRCA.pem"
CheckSum=
File=
FileName=
Json="{"
Manifest="manifest.json"
OwnCertificate="Certificates/pass.pem"
Password='"Metasec.2015"'
PrivateKey="Keys/private_key.key"
ScriptDirectory=`readlink -f "${0}"`; ScriptDirectory=`dirname "${ScriptDirectory}"`; ScriptDirectory="${ScriptDirectory%/}"/
Signature="signature"
TargetDirectory="${1%/}"/
TargetDirectoryName="${1%/}"; TargetDirectoryName="${TargetDirectoryName##*/}"

if [[ -d ${TargetDirectory} && `ls -A "${TargetDirectory}"` ]]; then
	for File in ${TargetDirectory}*; do
		FileName=`basename "${File}"`
		
		if [[ "${FileName}" != "manifest.json" && "${FileName}" != "signature" && "${FileName}" != "${TargetDirectoryName}.pkpass" ]]; then
			CheckSum=`sha1sum ${File} | cut -d\  -f1`
			Json+=`printf '"%s":"%s",' "${FileName}" "${CheckSum}"`
		fi;
	done
	Json="${Json%,}}"
	touch "${TargetDirectory}${Manifest}"
	echo -e "${Json}" > "${TargetDirectory}${Manifest}"
	openssl smime -binary -sign -signer "${ScriptDirectory}${OwnCertificate}" -inkey "${ScriptDirectory}${PrivateKey}" -passin pass:"${Password}" -certfile "${ScriptDirectory}${AppleCertificate}" -in "${TargetDirectory}${Manifest}" -out "${TargetDirectory}${Signature}" -outform DER
	cd "${TargetDirectory}"
	if [ -e "${TargetDirectoryName}.pkpass" ]; then
		rm "${TargetDirectoryName}.pkpass"
	fi;
	zip -qr "${TargetDirectoryName}.pkpass" *
fi;
